Generic Image Library: Performance overloads of STL algorithms

###  | #  |

Functions
Performance overloads of STL algorithms
Image View » Algorithms and Utility Functions

overloads of STL algorithms allowing more efficient implementation when used with GIL constructs More...

## Functions
template<typename T, typename CS>
BOOST_FORCEINLINE auto | copy (boost::gil::pixel< T, CS > *first, boost::gil::pixel< T, CS > *last, boost::gil::pixel< T, CS > *dst) -> boost::gil::pixel< T, CS > *
| Copy when both src and dst are interleaved and of the same type can be just memmove.
template<typename T, typename CS>
BOOST_FORCEINLINE auto | copy (const boost::gil::pixel< T, CS > *first, const boost::gil::pixel< T, CS > *last, boost::gil::pixel< T, CS > *dst) -> boost::gil::pixel< T, CS > *
| Copy when both src and dst are interleaved and of the same type can be just memmove.
template<typename CS, typename IC1, typename IC2>
BOOST_FORCEINLINE auto | copy (boost::gil::planar_pixel_iterator< IC1, CS > first, boost::gil::planar_pixel_iterator< IC1, CS > last, boost::gil::planar_pixel_iterator< IC2, CS > dst) -> boost::gil::planar_pixel_iterator< IC2, CS >
| Copy when both src and dst are planar pointers is copy for each channel.
template<typename IL, typename OL>
BOOST_FORCEINLINE auto | copy1 (boost::gil::iterator_from_2d< IL > first, boost::gil::iterator_from_2d< IL > last, boost::gil::iterator_from_2d< OL > dst) -> boost::gil::iterator_from_2d< OL >
| std::copy(I1,I1,I2) with I1 and I2 being a iterator_from_2d
template<typename IL, typename V>
void | fill (boost::gil::iterator_from_2d< IL > first, boost::gil::iterator_from_2d< IL > last, const V &val)
| std::fill(I,I,V) with I being a iterator_from_2d
template<typename Loc1, typename Loc2>
BOOST_FORCEINLINE bool | equal (boost::gil::iterator_from_2d< Loc1 > first, boost::gil::iterator_from_2d< Loc1 > last, boost::gil::iterator_from_2d< Loc2 > first2)
| std::equal(I1,I1,I2) with I1 and I2 being a iterator_from_2d

## Detailed Description

overloads of STL algorithms allowing more efficient implementation when used with GIL constructs

## Function Documentation

## ◆ equal()

template<typename Loc1, typename Loc2>

BOOST_FORCEINLINE bool equal | ( | boost::gil::iterator_from_2d< Loc1 > | first,
|  | boost::gil::iterator_from_2d< Loc1 > | last,
|  | boost::gil::iterator_from_2d< Loc2 > | first2 )

std::equal(I1,I1,I2) with I1 and I2 being a iterator_from_2d

Invoked when one calls std::equal(I1,I1,I2) with I1 and I2 being a iterator_from_2d (which is a 1D iterator over the pixels in an image). Attempts to demote the source and destination iterators to simpler/faster types if the corresponding range is contiguous. For contiguous images (i.e. images that have no alignment gap at the end of each row) it is more efficient to use the underlying pixel iterator that does not check for the end of rows. If the underlying pixel iterator happens to be a fundamental planar/interleaved pointer, the call may further resolve to memcmp. Otherwise it resolves to copying each row using the underlying pixel iterator

## ◆ fill()

template<typename IL, typename V>

void fill | ( | boost::gil::iterator_from_2d< IL > | first,
|  | boost::gil::iterator_from_2d< IL > | last,
|  | const V & | val )

std::fill(I,I,V) with I being a iterator_from_2d

Invoked when one calls std::fill(I,I,V) with I being a iterator_from_2d (which is a 1D iterator over the pixels in an image). For contiguous images (i.e. images that have no alignment gap at the end of each row) it is more efficient to use the underlying pixel iterator that does not check for the end of rows. For non-contiguous images fill resolves to fill of each row using the underlying pixel iterator, which is still faster